#define _GNU_SOURCE
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>

#include <arpa/inet.h>
#include <sys/socket.h>

#include <sys/wait.h>
#include <string.h>

#include <signal.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) { \
			perror(userMsg);\
			exit(EXIT_FAILURE); \
		} \
	} while (0)
#define MAX_SIZE (1024)

// ./1 addr 127.0.0.1 port
int main(int argc, char** argv){
	
	int sockFd;
	struct sockaddr_in serverAddr;
	
	check_error(argc == 3, "...");
	
	sockFd = socket(AF_INET, SOCK_STREAM, 0);
	check_error(sockFd != -1, "...");
	
	memset(&serverAddr, 0, sizeof(struct sockaddr_in));
	serverAddr.sin_family = AF_INET;
	serverAddr.sin_port = htons(atoi(argv[2]));
	inet_pton(AF_INET, argv[1], &serverAddr.sin_addr);
	
	check_error(connect(sockFd, &serverAddr, sizeof(struct sockaddr_in)) != -1, "....");
	
	char buffer[MAX_SIZE];
	int bytesRead = read(sockFd, buffer, MAX_SIZE);
	
	check_error(bytesRead != -1, "....");
	
	check_error(write(STDOUT_FILENO, buffer, bytesRead) != -1, "...");
	
	close(sockFd);
	
	exit(EXIT_SUCCESS);
}
