#define _GNU_SOURCE
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <arpa/inet.h>
#include <sys/socket.h>

#include <string.h>
#include <sys/wait.h>

#include <signal.h>

#define check_error(expr,userMsg)\
	do{ \
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		} \
	} while (0)
	
#define PORT (8080)
#define MAX_SIZE (1024)

// ./1 127.0.0.1 8080
int main(int argc, char** argv){
	
	check_error(argc == 3, "....");
	
	int connFd;
	struct sockaddr_in serverAddr;
	
	connFd = socket(AF_INET, SOCK_STREAM, 0);
	check_error(connFd != -1, "...");
	
	memset(&serverAddr, 0, sizeof(struct sockaddr_in));
	serverAddr.sin_family = AF_INET;
	serverAddr.sin_port = htons(atoi(argv[2]));
	inet_pton(AF_INET, argv[1], &serverAddr.sin_addr);
	
	check_error(connect(connFd, &serverAddr, sizeof(struct sockaddr_in)) != -1, "...");
	
	char buffer[MAX_SIZE];
	int bytesRead = read(connFd, buffer, MAX_SIZE);
	check_error(bytesRead != -1, "...");
	
	check_error(write(STDOUT_FILENO, buffer, bytesRead) != -1, "...");
	
	close(connFd);
	
	exit(EXIT_SUCCESS);
}
