#define _GNU_SOURCE
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <math.h>
#include <pthread.h>
#include <errno.h>

#include <signal.h>
#include <string.h>
#include <ctype.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		} \
	} while (0)

#define check_pthread(err,userMsg)\
	do {\
		int _err = (err); \
		if (_err > 0) { \
			errno = _err;\
			check_error(0, userMsg);\
		}\
	} while (0)
	
#define MAX_SIZE (64)

int usr1 = 0;
int usr2 = 0;
int run = 1;

void processSignal(int signum) {

	switch (signum) {
		case SIGUSR1:
			usr1 = 1;
			break;
		case SIGUSR2:
			usr2 = 1;
			break;
		case SIGTERM:
			run = 0;
			break;
	}
}


int main(int argc, char** argv){
	
	check_error(argc == 1, "...");
	
	check_error(signal(SIGUSR1, processSignal) != SIG_ERR, "....");
	check_error(signal(SIGUSR2, processSignal) != SIG_ERR, "....");
	check_error(signal(SIGTERM, processSignal) != SIG_ERR, "....");
	
	do {
		
		char s[MAX_SIZE];
		scanf("%s", s);
		
		pause();
		
		if (usr1) {
			
			int n = strlen(s);
			for (int i = 0; i < n/2; i++) {
				char tmp = s[i];
				s[i] = s[n-1-i];
				s[n-1-i] = tmp;
			}
			
			printf("%s\n", s);
			
			usr1 = 0;
		}
		
		if (usr2) {
			
			for (int i = 0; s[i] != 0; i++) {
				if (islower(s[i])) {
					s[i] = toupper(s[i]);
				}
			}
			
			printf("%s\n", s);
			
			usr2 = 0;
		}
		
	} while(run);
	
	exit(EXIT_SUCCESS);
}
