#define _GNU_SOURCE
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <math.h>
#include <pthread.h>
#include <errno.h>

#include <signal.h>
#include <string.h>
#include <ctype.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		} \
	} while (0)

#define check_pthread(err,userMsg)\
	do {\
		int _err = (err); \
		if (_err > 0) { \
			errno = _err;\
			check_error(0, userMsg);\
		}\
	} while (0)
	
#define MAX_SIZE (257)

#define RD_END (0)
#define WR_END (1)

int main(int argc, char** argv){
	
	check_error(argc == 2, "...");
	
	int par2cld[2];
	check_error(pipe(par2cld) != -1, "...");
	
	pid_t childPid = fork();
	check_error(childPid != -1, "...");
	
	if (childPid == 0) {
		
		close(par2cld[RD_END]);
		
		check_error(dup2(par2cld[WR_END], STDOUT_FILENO) != -1, "...");
		
		check_error(execlp("find", "find",".","-type","f", NULL) != -1, "...");
	}
	
	close(par2cld[WR_END]);
	
	FILE* f = fdopen(par2cld[RD_END], "r");
	check_error(f != NULL, "...");
	
	char* line = NULL;
	size_t lineLen = 0;
	int br = 0;
	while (getline(&line, &lineLen, f) != -1) {
		
		char* tacka = strrchr(line, '.');
		int n = strlen(argv[1]);
		
		if (tacka != NULL && strncmp(tacka, argv[1], n) == 0) {
			br++;
		}
		
		
	}
	
	printf("%d\n", br);
	
	fclose(f);
	free(line);

	exit(EXIT_SUCCESS);
}
