#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>

#include <pthread.h>
#include <errno.h>

#include <string.h>

#define check_error(expr,userMsg)\
	do { \
		if (!(expr)){\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

#define check_pthread(err,userMsg)\
	do {\
		int _err = (err);\
		if (_err > 0) {\
			errno = _err;\
			check_error(0,userMsg);\
		}\
	}while (0)

#define MAX_SIZE 256

	
int main(int argc, char** argv) {
	
	check_error(argc == 3, "....");
	
	int fd = open(argv[1], O_RDWR);
	check_error(fd != -1, "...");
	
	FILE* f = fdopen(fd, "r+");
	check_error(f != NULL, "...");
	
	char buffer[MAX_SIZE];
	while (fscanf(f, "%s", buffer) == 1){
		
		if (!strcmp(buffer, argv[2])) {
			
			struct flock lock;
			lock.l_type = F_WRLCK;
			lock.l_whence = SEEK_SET;
			lock.l_start = ftell(f);
			lock.l_len = -strlen(buffer);
			
			check_error(fcntl(fd, F_GETLK, &lock) != -1, "...");
			
			switch (lock.l_type){
				case F_RDLCK:
					printf("%ld r\n", ftell(f) - strlen(buffer));
					break;
				case F_WRLCK:
					printf("%ld w\n", ftell(f) - strlen(buffer));
					break;
			}
		}
	}
	
	check_error(feof(f), ".....");
	
	fclose(f);
	
	exit(EXIT_SUCCESS);
}
