#define _GNU_SOURCE
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>

#include <pthread.h>
#include <errno.h>

#include <string.h>
#include <sys/wait.h>

#include <signal.h>

#define check_error(expr,userMsg)\
	do { \
		if (!(expr)){\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

#define check_pthread(err,userMsg)\
	do {\
		int _err = (err);\
		if (_err > 0) {\
			errno = _err;\
			check_error(0,userMsg);\
		}\
	}while (0)

int run = 1;
int usr1 = 0;
int usr2 = 0;

void processSignal(int signum) {
	
	switch (signum){
		case SIGUSR1:
			usr1 = 1;
			break;
		case SIGUSR2:
			usr2 = 1;
			break;
		case SIGTERM:
			run = 0;
			break;
	}
}
	
int main(int argc, char** argv) {
	
	check_error(argc == 1, "...");
	
	check_error(signal(SIGUSR1, processSignal) != SIG_ERR,"...");
	check_error(signal(SIGUSR2, processSignal) != SIG_ERR,"...");
	check_error(signal(SIGTERM, processSignal) != SIG_ERR,"...");
	int x;
	do {
		
		pause();
		
		if (usr1) {
			scanf("%d", &x);
			printf("%d\n", x < 0 ? -x : x);
			usr1 = 0;
		}
		
		if (usr2) {
			scanf("%d", &x);
			printf("%d\n", x*x);
			usr2 = 0;
		}
		
	} while (run);
	
	exit(EXIT_SUCCESS);
}
