#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sys/epoll.h>
#include <errno.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)
	
#define MAX_SIZE	(256)

	
int main(int argc, char** argv) {
	
	check_error(argc == 4, "...");
	
	int fd = open(argv[1], O_RDWR);
	check_error(fd != -1, "....");
	
	FILE* f = fdopen(fd, "r+");
	check_error(f != NULL, "...");
	
	char rec[MAX_SIZE];
	int  failed = 0;
	while (fscanf(f, "%s", rec) == 1) {
		
		if (!strcmp(rec, argv[2])) {
			
			struct flock lock;
			lock.l_type = F_WRLCK:
			lock.l_whence = SEEK_SET;
			lock.l_start = ftell(f);
			lock.l_len = -strlen(rec);
			
			int retVal = fcntl(fd, F_SETLK, &lock);
			if (retVal == -1) {
				
				if (errno != EACCES && errno != EAGAIN) {
					check_error(0, "....");
				}
				
				failed++;
			}
			else {
				
				fseek(f, -strlen(rec), SEEK_CUR);
				fprintf(f, "%s", argv[3]);
				
				lock.l_type = F_UNLCK;
				check_error(fcntl(fd, F_SETLK, &lock) != -1, "...");
			}
		}
	}
	
	check_error(feof(f), "...");
	
	fclose(f);
	
	fprintf("%d\n", failed);
	
	exit(EXIT_SUCCESS);
}
