#define _GNU_SOURCE
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sys/epoll.h>
#include <errno.h>
#include <sys/wait.h>

#include <signal.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)
	
int usr1 = 0;
int usr2 = 0;
int run = 1;	
	
void processSignal(int signum) {
	
	switch (signum) {
		
		case SIGUSR1:
			usr1 = 1;
			break;
		case SIGUSR2:
			usr2 = 2;
			break;
		case SIGTERM:
			run = 0;
			break;
	}
}
	
int main(int argc, char** argv) {
	
	
	int x;
	do {
		check_error(signal(SIGUSR1, processSignal) != SIG_ERR, "...");
		check_error(signal(SIGUSR2, processSignal) != SIG_ERR, "...");
		check_error(signal(SIGTERM, processSignal) != SIG_ERR, "...");
		
		pause();
		
		if (usr1) {
			
			scanf("%d", &x);
			printf("%d\n", x < 0 ? -x : x);
			
			usr1 = 0;
		}
		
		if (usr2) {
			
			scanf("%d", &x);
			printf("%d\n", x*x);
			
			usr2 = 0;
		}
		
	} while (run);
	
	exit(EXIT_SUCCESS);
}
