#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <sys/wait.h>

#define check_error(expr,userMsg)\
	do { \
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

#define RD_END (0)
#define WR_END (1)
int main(int argc, char** argv){
	
	check_error(argc == 2, "...");
	
	int cld2par[2];
	check_error(pipe(cld2par) != -1, "...");
	
	pid_t childPid = fork();
	check_error(childPid != -1, "....");
	
	if (childPid == 0) {
		
		close(cld2par[RD_END]);
		
		check_error(dup2(cld2par[WR_END], STDOUT_FILENO) != -1, "..."); 
		
		check_error(execlp("ls", "ls", "-l", argv[1], NULL) != -1, "...");
	}
	
	close(cld2par[WR_END]);
	
	FILE* f = fdopen(cld2par[RD_END], "r");
	check_error(f != NULL, "...");
	
	char* line = NULL;
	size_t lineLen = 0;
	int i = 0;
	while (getline(&line, &lineLen, f) != -1) {
		
		char buffer[50];
		sscanf(line, "%*s%*s%*s%*s%*s%*s%*s%s", buffer);
		if (i > 0)
			printf("%s\n", buffer);
		i++;
	}
	
	free(line);
	fclose(f);
	
	check_error(wait(NULL) != -1, "...");
	
	exit(EXIT_SUCCESS);
}
