#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <errno.h>
#include <string.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

#define MAX_SIZE (257)

int main(int argc, char** argv){
	
	check_error(argc == 2, "...");
	
	int fd = open(argv[1], O_RDWR);
	check_error(fd != -1, "....");
	
	FILE* f = fdopen(fd, "r+");
	check_error(f != NULL, "...");
	
	char buffer[MAX_SIZE];
	while (fscanf(f, "%s", buffer) == 1) {
		
		int n = strlen(buffer);
		
		if (n != 4) {
			continue;
		}
		
		char* inv = NULL;
		int br = strtol(buffer, &inv, 10);
		
		if (((buffer == inv) && br == 0) || (inv != NULL && *inv != '\0')) {
			
			continue;
		}
		
		if (br >= 1000 && br <= 9999) {
			
			struct flock lock;
			lock.l_type = F_WRLCK;
			lock.l_whence = SEEK_SET;
			lock.l_start = ftell(f);
			lock.l_len = -n;
			
			int retVal = fcntl(fd, F_SETLK, &lock);
			if (retVal != -1) {
				
				fseek(f, -n, SEEK_CUR);
				
				fprintf(f, "####");
				
				lock.l_type = F_UNLCK;
				
				check_error(fcntl(fd, F_SETLK, &lock) != -1, "....");
			}
			else {
				if (errno != EAGAIN && errno != EACCES) {
					check_error(0, "....");
				}
			}
		}
	}
	
	check_error(feof(f), "....");
	
	fclose(f);
	
	exit(EXIT_SUCCESS);
}
