#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)){\
			fprintf(stderr,"%s\n",userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

#define MAX_SIZE (8192)

int main(int argc, char** argv) {
	
	check_error(argc == 3, "argumenti");
	
	int fdIn = open(argv[1], O_RDONLY);
	check_error(fdIn != -1, "source open");
	int fdOut = open(argv[2], O_WRONLY|O_CREAT|O_TRUNC, 0644);
	check_error(fdOut != -1, "dest open");
		
	char* buffer = malloc(MAX_SIZE*sizeof(char));
	check_error(buffer != NULL, "malloc");
	
	int bytesRead = 0;
	while ((bytesRead = read(fdIn, buffer, MAX_SIZE)) > 0){
		check_error(write(fdOut, buffer, bytesRead) != -1, "write");
	}
	
	check_error(bytesRead != -1, "read");
	
	close(fdIn);
	close(fdOut);
	free(buffer);
	
	exit(EXIT_SUCCESS);
}
