#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)){\
			fprintf(stderr,"%s\n",userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

int main(int argc, char** argv) {
	
	check_error(argc == 2, "argumenti");
	
	int fd = open(argv[1], O_RDONLY);
	check_error(fd != -1, "open");
	
	off_t fileSize = lseek(fd, 0, SEEK_END);
	check_error(fileSize != (off_t)-1, "lseek");
	
	printf("File size: %jd\n", (intmax_t)fileSize);
	
	close(fd);
	
	exit(EXIT_SUCCESS);
}
