#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)){\
			fprintf(stderr,"%s\n",userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

//. prog -[f|d] putanja
int main(int argc, char** argv) {
	
	check_error(argc == 3, "argumenti");
	
	if (strcmp(argv[1],"-f") == 0) {
		check_error(unlink(argv[2]) != -1, "unlink");
	}
	else if (strcmp(argv[1], "-d") == 0) {
		check_error(rmdir(argv[2]) != -1, "rmdir");
	}
	else {
		check_error(0, "pogresna opcija");
	}
	
	exit(EXIT_SUCCESS);
}
