#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			fprintf(stderr,"%s\n",userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

#define MAX_SIZE (1024)

int main(int argc, char** argv){
	
	check_error(argc == 2, "argumenti");
	
	int fd = open(argv[1], O_RDONLY);
	check_error(fd != -1, "open");
	
	char buffer[MAX_SIZE];
	int bytesRead = 0;
	
	while ((bytesRead = read(fd, buffer, MAX_SIZE)) > 0) {
		
		//buffer[bytesRead] = 0;
		//printf("%s", buffer);
		
		check_error(write(STDOUT_FILENO, buffer, bytesRead) != -1, "");
	}
	
	check_error(bytesRead != -1, "read");
	
	close(fd);
	
	exit(EXIT_SUCCESS);
}
