#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>

#include <grp.h>

#define check_error(expr,userMsg) \
	do {\
		if (!(expr)) {\
			fprintf(stderr,"%s\n", userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while(0)
	
int main(int argc, char** argv){
	
	check_error(argc == 2, "argumenti");
	
	struct group* grInfo = getgrnam(argv[1]);
	check_error(grInfo != NULL, "getgrnam");
	
	printf("Group name: %s\n", grInfo->gr_name);
	printf("Group password: %s\n", grInfo->gr_passwd);
	printf("Group ID: %d\n", (int)grInfo->gr_gid);
	printf("Members: \n");
	int i;
	for (i = 0; grInfo->gr_mem[i] != NULL; i++) {
		printf("\t%s\n", grInfo->gr_mem[i]);
	}
		
	exit(EXIT_SUCCESS);
}
