#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>

#include <grp.h>

#define check_error(expr,userMsg) \
	do {\
		if (!(expr)) {\
			fprintf(stderr,"%s\n", userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while(0)
	
void printGroup(struct group* grInfo) {
	
	printf("Group name: %s\n", grInfo->gr_name);
	printf("Group password: %s\n", grInfo->gr_passwd);
	printf("Group ID: %d\n", (int)grInfo->gr_gid);
	printf("Members: \n");
	int i;
	for (i = 0; grInfo->gr_mem[i] != NULL; i++) {
		printf("\t%s\n", grInfo->gr_mem[i]);
	}
	printf("***************************\n");
}	
	
int main(int argc, char** argv){
	
	check_error(argc == 1, "argumenti");
	
	setgrent();
	
	struct group* gr;
	while((gr = getgrent()) != NULL) {
		
		printGroup(gr);
	}
	
	endgrent();
	
	
		
	exit(EXIT_SUCCESS);
}
