#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>

#include <pwd.h>

#define check_error(expr,userMsg) \
	do {\
		if (!(expr)) {\
			fprintf(stderr,"%s\n", userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while(0)

void printUser(struct passwd* userInfo) {
	
	printf("Username: %s\n", userInfo->pw_name);
	printf("User ID: %jd\n", (intmax_t)userInfo->pw_uid);
	printf("Group ID: %jd\n", (intmax_t)userInfo->pw_gid);
	printf("User info: %s\n", userInfo->pw_gecos);
	printf("Home directory: %s\n", userInfo->pw_dir);
	printf("Shell: %s\n", userInfo->pw_shell);
	printf("****************************************************\n");
}

int main(int argc, char** argv){
	
	check_error(argc == 1, "argumenti");
	
	setpwent();
	
	struct passwd* userInfo;
	while ((userInfo = getpwent()) != NULL){
		
		printUser(userInfo);
	}
	
	endpwent();

	exit(EXIT_SUCCESS);
}
