#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <grp.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			fprintf(stderr, "%s\n", userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while(0)
	
int main(int argc, char** argv){
	
	check_error(argc == 2, "argumenti");
	
	struct group* grpInfo = getgrnam(argv[1]);
	check_error(grpInfo != NULL, "getgrnam");
	
	printf("Group name: %s\n", grpInfo->gr_name);
	printf("Group password: %s\n", grpInfo->gr_passwd);
	printf("Group ID: %d\n", (int)grpInfo->gr_gid);
	printf("Group members:\n");
	for (int i = 0; grpInfo->gr_mem[i] != NULL; i++){
		printf("\t%s\n", grpInfo->gr_mem[i]);
	}
	
	exit(EXIT_SUCCESS);
}
