#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <pwd.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			fprintf(stderr, "%s\n", userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while(0)

void printUser(struct passwd* userInfo){
	
	printf("User name: %s\n", userInfo->pw_name);
	printf("User ID: %d\n", (int)userInfo->pw_uid);
	printf("Group ID: %d\n", (int)userInfo->pw_gid);
	printf("User info: %s\n", userInfo->pw_gecos);
	printf("Home dir: %s\n", userInfo->pw_dir);
	printf("User shell: %s\n", userInfo->pw_shell);
	printf("*****************************************\n");
}

int main(int argc, char** argv){
	
	check_error(argc == 1, "argumenti");
	
	setpwent();
	
	struct passwd* currUser = NULL;
	while ((currUser = getpwent()) != NULL) {
		printUser(currUser);
	}
	
	endpwent();
	
	exit(EXIT_SUCCESS);
}
