#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <utime.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			fprintf(stderr, "%s\n", userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while(0)
	
int main(int argc, char** argv){
	
	check_error(argc == 2, "argumenti");
	
	struct stat fInfo;
	check_error(stat(argv[1], &fInfo) != -1, "...");
	
	FILE* f = fopen(argv[1], "w");
	fclose(f);
	
	struct utimbuf vreme;
	vreme.actime = fInfo.st_atime;
	vreme.modtime = fInfo.st_mtime;
	
	check_error(utime(argv[1], &vreme) != -1, "...");
	
	exit(EXIT_SUCCESS);
}
