#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <grp.h>

#define check_error(expr,userMsg) \
	do {\
		if (!(expr)){\
			fprintf(stderr,"%s\n", userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while(0)
	
void printGroup(struct group* groupInfo) {
	
	printf("Group name: %s\n", groupInfo->gr_name);
	printf("Group password: %s\n", groupInfo->gr_passwd);
	printf("Group ID: %d\n", (int)groupInfo->gr_gid);
	printf("Group memebers:\n");
	for (int i = 0; groupInfo->gr_mem[i] != NULL; i++) {
		
		printf("\t%s\n", groupInfo->gr_mem[i]);
	}
	printf("************************************\n");
}

int main(int argc, char** argv){
	
	check_error(argc == 1, "argumenti");
	
	setgrent();
	
	struct group* currGrp = NULL;
	while ((currGrp = getgrent()) != NULL) {
		printGroup(currGrp);
	}
	
	endgrent();

	exit(EXIT_SUCCESS);
}
