#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <dirent.h>
#include <errno.h>
#include <string.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

void sizeOfDir(char* putanja, unsigned* psize);

// 1./ putanja
int main(int argc, char** argv) {
	
	check_error(argc == 2, "argumenti");
	
	struct stat fInfo;
	check_error(stat(argv[1], &fInfo) != -1, "stat");
	check_error(S_ISDIR(fInfo.st_mode), "nije dir");
	
	unsigned size = 0;
	sizeOfDir(argv[1], &size);
	
	printf("Dir size: %uB\n", size);
	
	exit(EXIT_SUCCESS);
}

void sizeOfDir(char* putanja, unsigned* psize) {
	
	struct stat fInfo;
	check_error(lstat(putanja, &fInfo) != -1, "...");
	
	*psize += fInfo.st_size;
	
	if (!S_ISDIR(fInfo.st_mode))
		return;
		
	
	DIR* dir = opendir(putanja);
	check_error(dir != NULL, "opendir");
	
	struct dirent* dirEntry = NULL;
	while ((dirEntry = readdir(dir)) != NULL) {
		
		char* path = malloc(strlen(putanja) + strlen(dirEntry->d_name) + 2);
		check_error(path != NULL, "alokacija");
		
		strcpy(path, putanja);
		strcat(path, "/");
		strcat(path, dirEntry->d_name);
		
		if (!strcmp(dirEntry->d_name, ".") || !strcmp(dirEntry->d_name, "..")){
			
			check_error(stat(path, &fInfo) != -1, "...");
			*psize += fInfo.st_size;
			
			free(path);
			continue;
		}
		
		sizeOfDir(path, psize);
		
		free(path);
	}
	
	check_error(errno != EBADF, "dir error");
	
	check_error(closedir(dir) != -1, "...");
}
