#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <dirent.h>
#include <errno.h>

#include <string.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)
	
void sizeOfDir(char* putanja, unsigned* psize);	
	
int main(int argc, char** argv){
	
	check_error(argc == 2, "argumenti");
	
	struct stat fInfo;
	check_error(stat(argv[1], &fInfo) != -1, "....");
	
	check_error(S_ISDIR(fInfo.st_mode), "not a dir");
	
	unsigned size = 0;
	sizeOfDir(argv[1], &size);
	
	printf("Dir size: %d\n", size);
	
	exit(EXIT_SUCCESS);
}

void sizeOfDir(char* putanja, unsigned* psize) {
	
	struct stat fInfo;
	check_error(lstat(putanja, &fInfo) != -1,"stat");
	
	*psize += fInfo.st_size;
	
	if (!S_ISDIR(fInfo.st_mode)) {
		return;
	}
	
	DIR* dir = opendir(putanja);
	check_error(dir != NULL, "opendir");
	
	struct dirent* currEntry;
	while ((currEntry = readdir(dir)) != NULL) {
		
		char* novaPutanja = malloc((strlen(putanja) + strlen(currEntry->d_name) + 2)*sizeof(char));
		check_error(novaPutanja != NULL, "malloc");
		
		strcpy(novaPutanja, putanja);
		strcat(novaPutanja, "/");
		strcat(novaPutanja, currEntry->d_name);
		
		if (!strcmp(currEntry->d_name, ".") || !strcmp(currEntry->d_name, "..")) {
			
			check_error(stat(novaPutanja, &fInfo) != -1, "...");
			*psize += fInfo.st_size;
			
			free(novaPutanja);
			continue;
		}
		
		sizeOfDir(novaPutanja, psize);
		
		free(novaPutanja);
	}
	
	check_error(errno != EBADF, "readdir");
	
	check_error(closedir(dir) != -1, "closedir");
}
