#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <dirent.h>
#include <errno.h>

#include <string.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)
	
void sizeOfDir(char* putanja, unsigned* psize);	
	
int main(int argc, char** argv){
	
	check_error(argc == 2, "argumenti");
	
	struct stat fInfo;
	check_error(stat(argv[1], &fInfo) != -1, "....");
	
	check_error(S_ISDIR(fInfo.st_mode), "not a dir");
	
	unsigned size = 0;
	sizeOfDir(argv[1], &size);
	
	printf("Dir size: %d\n", size);
	
	exit(EXIT_SUCCESS);
}

void sizeOfDir(char* putanja, unsigned* psize) {
	
	struct stat fInfo;
	check_error(lstat(putanja, &fInfo) != -1, "stat");
	
	*psize += fInfo.st_size;
	
	if (!S_ISDIR(fInfo.st_mode)){
		return;
	}
	
	char* apsolutnaPutanja = realpath(putanja, NULL);
	printf("Dir path: %s\n", apsolutnaPutanja);
	free(apsolutnaPutanja);
	
	DIR* dir = opendir(putanja);
	check_error(dir != NULL, "...");
	
	check_error(chdir(putanja) != -1, "chdir");
	
	struct dirent* curr;
	while ((curr = readdir(dir)) != NULL) {
		
		apsolutnaPutanja = realpath(curr->d_name, NULL);
		printf("\tFile path: %s : %s\n", apsolutnaPutanja, curr->d_name);
		free(apsolutnaPutanja);
		
		if (!strcmp(curr->d_name, ".") || !strcmp(curr->d_name, "..")) {
			
			check_error(stat(curr->d_name, &fInfo) != -1, "...");
			*psize += fInfo.st_size;			
			continue;
		}
		
		sizeOfDir(curr->d_name, psize);
	}
	
	check_error(errno != EBADF, "readdir");
	
	check_error(chdir("..") != -1, "chdir");
	check_error(closedir(dir) != -1, "closedir");
}
