#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <errno.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

// ./1 putanja 0777
int main(int argc, char** argv) {
	
	check_error(argc == 3, "argumenti");
	
	mode_t pravaPristupa = strtol(argv[2], NULL, 8);
	
	struct stat fInfo;
	int retVal = stat(argv[1], &fInfo);
	
	if (retVal == -1) {
		
		if (errno != ENOENT) {
			check_error(0, "stat");
		}
		
		int fd = open(argv[1], O_CREAT, pravaPristupa);
		check_error(fd != -1, "open");
		close(fd);
	}
	
	check_error(chmod(argv[1], pravaPristupa) != -1, "chmod");
	
	exit(EXIT_SUCCESS);
}
