#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <time.h>
#include <sys/time.h>

#include <string.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

// ./1 dir .txt
int main(int argc, char** argv) {
	
	const char* message="Mogu da pisem\n";
	
	int stdinFlags = fcntl(STDIN_FILENO, F_GETFL);
	check_error(stdinFlags != -1, "fcntl");
	
	int accessMode = stdinFlags & O_ACCMODE;
	if (accessMode == O_WRONLY || accessMode == O_RDWR) {
		
		//printf("Mogu da pisem\n");
		check_error(write(STDIN_FILENO, message, strlen(message)) != -1, "write");
	}
	
	int fd = open("1.txt", O_WRONLY, 0666);
	check_error(fd != -1, "....");
	
	check_error(write(fd, message, strlen(message)) != -1, "write");
	
	int fileFlags = fcntl(fd, F_GETFL);
	check_error(fileFlags != -1, "....");
	
	fileFlags &= ~O_WRONLY;
	fileFlags |= O_RDONLY;
	check_error(fcntl(fd, F_SETFL, fileFlags) != -1, "...");
	
	check_error(write(fd, message, strlen(message)) != -1, "write");
	
	close(fd);
	
	exit(EXIT_SUCCESS);
}
