#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <ftw.h>
#include <time.h>

#include <string.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

#define SEC_IN_HOUR (3600)
#define SEC_IN_DAY (24*SEC_IN_HOUR)


char* ext;

// dirA/dirB/dirC/1.c
// fpath + ftwbuf->base
// ftwbuf->level
int processFile(const char* fpath, const struct stat* sb, \
			int typeflag, struct FTW* ftwbuf){
	
	if (typeflag == FTW_F) {
		
		char* ekstenzija = strrchr(fpath+ftwbuf->base, '.');
		
		if (ekstenzija != NULL) {
			if (strcmp(ekstenzija+1, ext) == 0)
				printf("%s\n", fpath+ftwbuf->base);
		}
	}
	
	return 0;
}

// ./1 dir .txt
int main(int argc, char** argv) {
	
	check_error(argc == 3, "argumenti");
	
	struct stat fInfo;
	check_error(stat(argv[1], &fInfo) != -1, "stat");
	check_error(S_ISDIR(fInfo.st_mode), "nije dir");
	
	ext = argv[2];
	
	check_error(nftw(argv[1], processFile, 50, 0) != -1, "nftw");
	
	exit(EXIT_SUCCESS);
}
