#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <time.h>
#include <sys/time.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

// ./1 dir .txt
int main(int argc, char** argv) {
	
	time_t now = time(NULL);
	
	struct timeval preciseTime;
	check_error(gettimeofday(&preciseTime, NULL) != -1, "gettimeofday");
	
	if (now == preciseTime.tv_sec){
		printf("Isto vreme\n");
	}
	else {
		printf("Razlicito vreme\n");
	}
	printf("Microsekunde: %d\n", (int)preciseTime.tv_usec);
	
	struct tm* brokenTime = localtime(&now);
	check_error(brokenTime != NULL, "localtime");
	
	brokenTime->tm_year++;
	
	time_t movedTime = mktime(brokenTime);
	
	printf("%s", ctime(&movedTime));
	
	char timeString[1024];
	strftime(timeString, 1024, "Trenutno vreme: %H:%M:%S\n", brokenTime);
	printf("%s", timeString);
	
	exit(EXIT_SUCCESS);
}
