#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <ftw.h>
#include <time.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg); \
			exit(EXIT_FAILURE); \
		}\
	} while (0)

#define SEC_IN_HOUR (3600)
#define SEC_IN_DAY (24*SEC_IN_HOUR)

time_t now;

int processFile(const char* fpath, const struct stat* sb, \
					int typeflag, struct FTW* ftwbuf) {

	if (typeflag == FTW_F) {
		
		int timeDiff = (now - sb->st_mtime)/SEC_IN_DAY;
		if (timeDiff < 7){
			
			printf("%s\n", fpath + (ftwbuf->base));
		}
	}
	
	/*
	if (S_ISREG(sb->st_mode)) {
		
	}
	*/
	return 0;
}

int main(int argc, char** argv) {
	
	check_error(argc == 2, "...");
	
	struct stat fInfo;
	check_error(stat(argv[1], &fInfo) != -1, "....");
	
	check_error(S_ISDIR(fInfo.st_mode),"...");
	
	now = time(NULL);
	
	check_error(nftw(argv[1], processFile, 50, 0) != -1, "...");
	
	exit(EXIT_SUCCESS);
}
