#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <time.h>
#include <sys/time.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg); \
			exit(EXIT_FAILURE); \
		}\
	} while (0)

#define MAX_SIZE (1024)

int main(int argc, char** argv) {
	
	time_t now = time(NULL);
	
	time(&now);
	
	struct tm* brokenTime = localtime(&now);
	check_error(brokenTime != NULL, "....");
	
	brokenTime->tm_year++;
	
	printf("%d.%d.%d\n", brokenTime->tm_mday, brokenTime->tm_mon+1, brokenTime->tm_year + 1900);
	
	time_t pomerenoVreme = mktime(brokenTime);
	printf("%s", ctime(&pomerenoVreme));
	
	struct timeval preciznoVreme;
	check_error(gettimeofday(&preciznoVreme, NULL) != -1, "...");
	
	if (now == preciznoVreme.tv_sec) {
		printf("Vreme je isto\n");
	}
	else {
		printf("Vreme je razlicito\n");
	}
	printf("time je promasio: %d\n", (int)preciznoVreme.tv_usec);
	
	char formatiranoVreme[MAX_SIZE];
	strftime(formatiranoVreme, MAX_SIZE, "Trenutno vreme: %H:%M:%S\n", brokenTime);
	printf("%s", formatiranoVreme);
	
	exit(EXIT_SUCCESS);
}
