#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <ftw.h>
#include <time.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg); \
			exit(EXIT_FAILURE); \
		}\
	} while (0)

#define SEC_IN_HOUR (3600)
#define SEC_IN_DAY (24*SEC_IN_HOUR)

time_t now;

int processFile(const char* fpath, const struct stat* sb, \
					int typeflag, struct FTW* ftwbuf) {

	if (typeflag == FTW_F) {
		
		int timeDiff = (now - sb->st_mtime)/SEC_IN_DAY;
		if (timeDiff < 7){
			
			printf("%s\n", fpath + (ftwbuf->base));
		}
	}
	
	/*
	if (S_ISREG(sb->st_mode)) {
		
	}
	*/
	return 0;
}

int main(int argc, char** argv) {
	
	check_error(argc == 2, "...");
	
	struct stat fInfo;
	check_error(stat(argv[1], &fInfo) != -1, "...");
	
	/*
	mode_t pravaPristupa = fInfo.st_mode & S_IRWXU;
	pravaPristupa |= (fInfo.st_mode & S_IRWXG) >> 3;
	pravaPristupa |= (fInfo.st_mode & S_IRWXO) << 3;
	*/
	
	mode_t pravaPristupa = 0;
	
	if (fInfo.st_mode & S_IRUSR)
		pravaPristupa |= S_IRUSR;
	if (fInfo.st_mode & S_IWUSR)
		pravaPristupa |= S_IWUSR;
	if (fInfo.st_mode & S_IXUSR)
		pravaPristupa |= S_IXUSR;
		
	if (fInfo.st_mode & S_IRGRP)
		pravaPristupa |= S_IROTH;
	if (fInfo.st_mode & S_IWGRP)
		pravaPristupa |= S_IWOTH;
	if (fInfo.st_mode & S_IXGRP)
		pravaPristupa |= S_IXOTH;
		
	if (fInfo.st_mode & S_IROTH)
		pravaPristupa |= S_IRGRP;
	if (fInfo.st_mode & S_IWOTH)
		pravaPristupa |= S_IWGRP;
	if (fInfo.st_mode & S_IXOTH)
		pravaPristupa |= S_IXGRP;
	
	check_error(chmod(argv[1], pravaPristupa) != -1, "...");
	
	
	exit(EXIT_SUCCESS);
}
