#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <time.h>
#include <sys/time.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while(0)
// ./1 path .c
int main(int argc, char** argv) {
	
	time_t now = time(NULL);
	
	printf("%s", ctime(&now));
	
	struct tm* brokenTime = localtime(&now);
	check_error(brokenTime != NULL, "...");
	
	brokenTime->tm_year++;
	
	time_t pomerenoVreme = mktime(brokenTime);
	printf("Pomereno vreme: %s", ctime(&pomerenoVreme));
	
	struct timeval preciznoVreme;
	check_error(gettimeofday(&preciznoVreme, NULL) != -1, "...");
	
	if (now == preciznoVreme.tv_sec) {
		printf("Vreme je isto\n");
	}
	else {
		printf("Vreme nije isto\n");
	}
	printf("Broj mikrosekundi: %d\n", (int)preciznoVreme.tv_usec);
	
	char buffer[1024];
	strftime(buffer, 1024, "Trenutno vreme: %H:%M:%S %d:%m:%Y\n", brokenTime);
	printf("%s", buffer);
	
	exit(EXIT_SUCCESS);
}
