#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <time.h>
#include <sys/time.h>

#include <string.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while(0)

#define MAX_SIZE (256)	

// ./1 path .c
int main(int argc, char** argv) {
	
	check_error(argc == 3, "...");
	
	char* putanja1 = realpath(argv[1], NULL);
	check_error(putanja1 != NULL, "...");
	
	char* putanja2 = realpath(argv[2], NULL);
	if (putanja2 != NULL) {
		
		if (strcmp(putanja1, putanja2) == 0) {
			check_error(0, "ista_putanja");
		}
		
		free(putanja2);
	}
	free(putanja1);
	
	int srcFd = open(argv[1], O_RDONLY);
	check_error(srcFd != -1, "...");
	
	int destFd = open(argv[2], O_WRONLY|O_TRUNC|O_CREAT);
	check_error(destFd != -1, "...");
	
	struct stat fInfo;
	check_error(fstat(srcFd, &fInfo) != -1, "...");
	
	char buffer[MAX_SIZE];
	int readBytes = 0;
	
	while ((readBytes = read(srcFd, buffer, MAX_SIZE)) > 0) {
		
		check_error(write(destFd, buffer, readBytes) != -1, "....");
	}
	
	check_error(readBytes != -1, "...");
	
	close(srcFd);
	close(destFd);
	
	check_error(unlink(argv[1]) != -1, "...");
	
	check_error(chmod(argv[2], fInfo.st_mode) != -1, "...");
	
	exit(EXIT_SUCCESS);
}
