#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <sys/wait.h>

#include <errno.h>
#include <string.h>

#define check_error(expr,userMsg)\
	do{\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

#define RD_END (0)
#define WR_END (1)
#define MAX_SIZE (256)

int main(int argc, char** argv){
	
	check_error(argc == 2, "...");
	
	pid_t childPid = fork();
	check_error(childPid != -1, "...");
	
	if (childPid == 0) { // child
		
		check_error(execlp("gcc", "gcc", "-std=c99", argv[1], "-o", "prog", NULL) != -1, "exec");
		
		exit(EXIT_SUCCESS);
	}
	
	int status = 0;
	check_error(wait(&status) != -1, "...");
	
	if (WIFEXITED(status) && (WEXITSTATUS(status) == EXIT_SUCCESS)) {
		
		printf("Uspeh\n");
	}
	else {
		printf("Neuspeh\n");
	}
	 	
	exit(EXIT_SUCCESS);
}
