#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <sys/wait.h>

#define check_error(expr,userMsg)\
	do{\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)
	
int main(int argc, char** argv){
	
	pid_t childPid = fork();
	check_error(childPid != -1, "...");
	
	if (childPid > 0) { // parent
		
		printf("Parent:\nMy pid: %d\nChild Pid: %d\n", (int)getpid(), childPid);
	}
	else { // child
		
		printf("Child:\nMy pid: %d\nParent pid: %d\n", (int)getpid(),(int)getppid());
		exit(EXIT_SUCCESS);
	}
	
	int status = 0;
	check_error(wait(&status) != -1, "...");
	
	if (WIFEXITED(status)){
		if (WEXITSTATUS(status) == EXIT_SUCCESS) {
			
			printf("Child se zavrsio uspesno\n");
		}
		else {
			printf("Child se zavrsio neuspesno\n");
		}
	}
	
	printf("Ovo stampaju oba procesa\n");
	
	exit(EXIT_SUCCESS);
}
