#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>

#include <sys/wait.h>
#include <string.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while(0)

#define RD_END 		(0)
#define WR_END		(1)	
#define MAX_SIZE 	(1024)
	
int main(int argc, char** argv){
	
	pid_t childPid = fork();
	check_error(childPid != -1, "...");
	
	if (childPid == 0) { // child
		
		check_error(execlp("/home/nastava/Desktop/2019/os/5_1/pipes", "pipes", NULL) != -1, "...");
		exit(EXIT_SUCCESS);
	}
	
	int status = 0;
	check_error(wait(&status) != -1, "...");
	
	if (WIFEXITED(status) && (WEXITSTATUS(status) == EXIT_SUCCESS)) {
		printf("Uspeh\n" );
	}
	else {
		printf("Neuspeh\n");
	}
	
	exit(EXIT_SUCCESS);
}
