#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>

#include <sys/wait.h>
#include <string.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while(0)

#define RD_END 		(0)
#define WR_END		(1)	
#define MAX_SIZE 	(1024)
	
int main(int argc, char** argv){
	
	// gcc -std=c99 process.c -o process
	check_error(argc > 1, "...");
	
	char** opcije = malloc(argc*sizeof(char*));
	check_error(opcije != NULL, "...");
	int i;
	for ( i = 1; i < argc; i++) {
		opcije[i-1] = malloc(strlen(argv[i]) + 1);
		check_error(opcije[i-1] != NULL, "...");
		strcpy(opcije[i-1], argv[i]);
	}
	
	opcije[i-1] = NULL;
	
	pid_t childPid = fork();
	check_error(childPid != -1, "...");
	
	if (childPid == 0) {
		check_error(execvp(argv[1], opcije) != -1, "...");
	}
	
	int status= 0;
	
	check_error(wait(&status) != -1, "....");
	
	if (WIFEXITED(status) && (WEXITSTATUS(status) == EXIT_SUCCESS)) {
		printf("Uspeh\n" );
	}
	else {
		printf("Neuspeh\n");
	}
	
	free(opcije);
	
	exit(EXIT_SUCCESS);
}
