#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>

#include <sys/wait.h>
#include <string.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while(0)

#define RD_END 		(0)
#define WR_END		(1)	
#define MAX_SIZE 	(1024)
	
int main(int argc, char** argv){
	
	int cld2par[2];
	check_error(pipe(cld2par) != -1, "...");
	
	int par2cld[2];
	check_error(pipe(par2cld) != -1, "...");
	
	pid_t childPid = fork();
	check_error(childPid != -1, "..");
	
	if (childPid > 0) { // parent
		
		close(cld2par[WR_END]);
		close(par2cld[RD_END]);
		
		char buffer[MAX_SIZE];
		
		sprintf(buffer, "Zdravo!");
		check_error(write(par2cld[WR_END], buffer, strlen(buffer))!=-1,"....");
		
		int readBytes = read(cld2par[RD_END], buffer, MAX_SIZE);
		
		check_error(readBytes != -1, "...");
		
		check_error(write(STDOUT_FILENO, buffer, readBytes) != -1, "...");
		
		//buffer[readBytes] = 0;
		//printf("%s\n", buffer);
		
		close(par2cld[WR_END]);
		close(cld2par[RD_END]);
	}
	else { // child
		
		close(cld2par[RD_END]);
		close(par2cld[WR_END]);
		
		char buffer[MAX_SIZE];
		int readBytes = read(par2cld[RD_END], buffer, MAX_SIZE);
		
		check_error(readBytes != -1, "....");
		
		buffer[readBytes] = 0;
		
		char buffer2[MAX_SIZE];
		sprintf(buffer2, "Poruka od parenta: %s\n", buffer);
		
		check_error(write(cld2par[WR_END], buffer2, strlen(buffer2)) != -1, "..");
		
		close(cld2par[WR_END]);
		close(par2cld[RD_END]);
		
		exit(EXIT_SUCCESS);
	}
	
	check_error(wait(NULL) != -1, "...");
	
	exit(EXIT_SUCCESS);
}
