#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>

#include <sys/wait.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while(0)
	
int main(int argc, char** argv){
	
	pid_t childPid = fork();
	check_error(childPid != -1, "...");
	
	if (childPid) { // parent
		
		printf("Parent\nMy pid: %d\nChild pid: %d\n", (int)getpid(), (int)childPid);
	}
	else { // child
		
		printf("Child:\nMy pid: %d\nParent pid: %d\n", (int)getpid(), (int)getppid());
		exit(EXIT_SUCCESS);
	}
	
	int status = 0;
	check_error(wait(&status) != -1, "....");
	
	if (WIFEXITED(status)) {
		if (WEXITSTATUS(status) == EXIT_SUCCESS) {
			printf("Uspeh\n");
		}
		else {
			printf("Neuspeh");
		}
	}
	else {
		printf("Neuspeh\n");
	}
	
	printf("Ovo stampaju oba procesa\n");	
	
	exit(EXIT_SUCCESS);
}
