#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <sys/wait.h>

#define check_error(expr,userMsg)\
	do { \
		if (!(expr)){ \
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)
	
int main(int argc, char** argv) {
	
	int x = 10;
	int y = 5;
	
	pid_t childPid = fork();
	check_error(childPid != -1, "...");
	
	if (childPid > 0) { // parent
		x+=20;
		y-=20;
		printf("Parent: %d %d\n", x, y);
		
		check_error(wait(NULL) != -1, "...");
	}
	else { // child
		x-=20;
		y+=20;
		printf("Child: %d %d\n", x, y);
		
		//exit(EXIT_SUCCESS);
	}
	
	x += 50;
	y -= 50; 
	
	printf("%d %d\n", x, y);
	
	exit(EXIT_SUCCESS);
}
		
