#define GNU_SOURCE
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <errno.h>
#include <time.h>
#include <strings.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)
	
#define MAX_SIZE (256)

int main(int argc, char** argv){
	
	check_error(argc == 2, "...");
	
	int fd = open(argv[1], O_RDONLY);
	check_error(fd != -1, "...");
	
	int readBytes = 0;
	int x;
	while ((readBytes = read(fd, &x, sizeof(int))) > 0) {
		
		printf("Number received: %d\n", x);
	}
	
	check_error(readBytes != -1, "...");
	
	close(fd);
	
	exit(EXIT_SUCCESS);
}
