#define GNU_SOURCE
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <errno.h>
#include <time.h>
#include <strings.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)
	
#define MAX_SIZE (256)

int main(int argc, char** argv){
	
	check_error(argc == 2, "...");
	
	int retVal = mkfifo(argv[1], 0666);
	if (retVal == -1 && errno != EEXIST) {
		check_error(0, "mkfifo");
	}
	
	int fd = open(argv[1], O_WRONLY|O_TRUNC);
	check_error(fd != -1, "...");
	
	srand(time(NULL));
	char response[MAX_SIZE];
	
	do {
			
		int x = rand();
		check_error(write(fd, &x, sizeof(int)) != -1, "....");
		printf("Number sent: %d\n", x);
		printf("Send next number:(yes|no)\n");
		scanf("%s", response);
	} while (!strcasecmp("yes", response));
	
	close(fd);
	
	exit(EXIT_SUCCESS);
}
