#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <errno.h>
#include <time.h>
#include <strings.h>

#include <sys/mman.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)
	
#define MAX_SIZE (256)

void* getMemoryBlock(char* fpath, unsigned* size) {
	
	int memFd = shm_open(fpath, O_RDWR, 0600);
	check_error(memFd != -1, "...");
	
	struct stat fInfo;
	check_error(fstat(memFd, &fInfo) != -1, "...");
	*size = fInfo.st_size;
	
	void* addr = mmap(NULL, *size, PROT_READ|PROT_WRITE, MAP_SHARED, memFd, 0);
	check_error(addr != MAP_FAILED, "mmap");
	
	close(memFd);
	
	return addr;
}

int main(int argc, char** argv){
	
	check_error(argc == 2, "...");
	
	unsigned size = 0;
	int* array = getMemoryBlock(argv[1], &size);
	int n = size / sizeof(int);
	
	for (int i = 0; i < n; i++) {
		printf("%d ", array[i]);
	}
	printf("\n");
	
	check_error(munmap(array, 10*sizeof(int)) != -1, "....");
	
	check_error(shm_unlink(argv[1]) != -1 , "....");
	
	exit(EXIT_SUCCESS);
}
