#define GNU_SOURCE
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <signal.h>
#include <time.h>
#include <strings.h>
#include <errno.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

#define MAX_SIZE (1024)

int main(int argc, char** argv){
	
	check_error(argc == 2, "....");
	
	int retVal = mkfifo(argv[1], 0666);
	if (retVal == -1 && errno != EEXIST) {
		
		check_error(0, "....");
	}
	
	int fd = open(argv[1], O_WRONLY | O_TRUNC);
	check_error(fd != -1, "...");
	
	srand(time(NULL));
	char buffer[MAX_SIZE];
	
	do {
		
		int x = rand();
		check_error(write(fd, &x, sizeof(int)) != -1, "....");
		
		printf("Number sent: %d\n", x);
		printf("Send another: (yes|no)\n");
		scanf("%s", buffer);
		
	} while(!strcasecmp("yes", buffer));
	
	close(fd);
	
	exit(EXIT_SUCCESS);
}
