#define _GNU_SOURCE
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <time.h>
#include <errno.h>
#include <strings.h>

#define check_error(expr,userMsg)\
	do { \
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

#define MAX_SIZE (256)

int main(int argc, char** argv) {
	
	check_error(argc == 2, "...");
	
	int retVal = mkfifo(argv[1], 0660);
	if (retVal == -1) {
		
		if (errno != EEXIST) {
			check_error(0, "....");
		}
	}
	
	int fd = open(argv[1], O_WRONLY | O_TRUNC);
	check_error(fd != -1, "...");
	
	char buffer[MAX_SIZE];
	srand(time(NULL));
	
	do {
		
		int x = rand();
		printf("Number sent: %d\n", x);
		check_error(write(fd, &x, sizeof(int)) != -1, "....");
		
		printf("Send another number: (yes|no)\n");
		scanf("%s", buffer);
		
	} while (strcasecmp("no", buffer));
	
	close(fd);
	
	check_error(unlink(argv[1]) != -1, "..."); 
	
	exit(EXIT_SUCCESS);
}
