#define _GNU_SOURCE
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <time.h>
#include <errno.h>
#include <strings.h>
#include <sys/mman.h>

#define check_error(expr,userMsg)\
	do { \
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

#define MAX_SIZE (256)

void* createMemBlock(char* path, unsigned size){
	
	int memFd = shm_open(path, O_RDWR|O_CREAT, 0600);
	check_error(memFd != -1, "...");
	
	check_error(ftruncate(memFd, size) != -1, "...");
	
	void* addr = mmap(NULL, size, PROT_READ|PROT_WRITE, MAP_SHARED, memFd, 0);
	check_error(addr != MAP_FAILED, "...");
	
	close(memFd);
	
	return addr;
}

int main(int argc, char** argv) {
	
	check_error(argc == 2, "...");
	
	int n = 20;
	int* niz = createMemBlock(argv[1], n*sizeof(int));
	
	for (int i = 0; i < n; i++)
		niz[i] = i;
		
	check_error(munmap(niz, n*sizeof(int)) != -1, "....");
		
	exit(EXIT_SUCCESS);
}
