#define _XOPEN_SOURCE 700
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <errno.h>
#include <string.h>

#include <sys/wait.h>
#include <time.h>

#define check_error(expr,userMsg) \
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

#define RD_END 	(0)
#define WR_END	(1)
#define MAX_SIZE (1024)

int main(int argc, char** argv) {
	
	int cld2par[2];
	
	check_error(pipe(cld2par) != -1, "...");
	
	pid_t childPid = fork();
	check_error(childPid != -1, "...");
	
	if (childPid) { // parent
		
		close(cld2par[WR_END]);
		
		FILE* f = fdopen(cld2par[RD_END], "r");
		check_error(f != NULL, "....");
		
		char* line = NULL;
		size_t lineLen = 0;
		int lineCnt = 0;
		while (getline(&line, &lineLen, f) != -1) {
			
			lineCnt++;
			printf("%s", line);
		}
		
		printf("Ukupno linija: %d\n", lineCnt);
		
		free(line);
		fclose(f);		
	}
	else { // child
		
		close(cld2par[RD_END]);
		
		check_error(dup2(cld2par[WR_END], STDOUT_FILENO) != -1, "...");
		
		check_error(execlp("ls", "ls", "-l", NULL) != -1, "....");
		
		exit(EXIT_FAILURE);
	}
		
	int status = 0;
	check_error(wait(&status) != -1, "....");
	
	if (WIFEXITED(status) && (WEXITSTATUS(status) == EXIT_SUCCESS)) {
		
		printf("Uspeh\n");
	}
	else {
		
		printf("Neuspeh\n");
	}
	
	exit(EXIT_SUCCESS);
}
		
