#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <errno.h>
#include <string.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

int checkWriteEnd(char* path){
	
	int fd = open(path, O_RDONLY | O_NONBLOCK);
	check_error(fd != -1, "...");
	
	char c;
	int retVal = read(fd, &c, 1);
	
	if (retVal >= 0) {
		retVal = 1;
	}
	else {
		
		if (errno != EAGAIN) {
			
			check_error(0, "....");
		}
		
		retVal = 0;
	}
	
	close(fd);
	
	return retVal;
}

int checkReadEnd(char* path) {
	
	int fd = open(path, O_WRONLY | O_NONBLOCK);
	int retVal = 0;
	
	if (fd == -1) {
		if (errno != ENXIO) {
			check_error(0, "...");
		}
		retVal = 0;
	}
	else {
		
		retVal = 1;
		close(fd);
	}
	
	return retVal;
}

// ./1 -r|w filePath	
int main(int argc, char** argv) {
	
	check_error(argc == 3, "...");
	
	if (!strcmp(argv[1], "-r")) {
		
		printf("Otvoren za citanje: %s\n", !checkReadEnd(argv[2]) ? "yes" : "no");
	}
	else if (!strcmp(argv[1], "-w")){
		printf("Otvoren za pisanje: %s\n", !checkWriteEnd(argv[2]) ? "yes" : "no");
	}
	else {
		
		check_error(0, "...");
	}
	
	
	exit(EXIT_SUCCESS);
}
