#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <errno.h>
#include <string.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

// ./1 lock start numChar time file
int main(int argc, char** argv) {
	
	check_error(argc == 6, "...");
	struct flock lock;
	lock.l_type = argv[1][1] == 'r' ? F_RDLCK : F_WRLCK;
	lock.l_whence = SEEK_SET;
	lock.l_start = atoi(argv[2]);
	lock.l_len = atoi(argv[3]);
	int seconds = atoi(argv[4]);
	
	int fd = open(argv[5], O_RDWR);
	check_error(fd != -1, "....");
	
	check_error(fcntl(fd, F_SETLK, &lock) != -1, "....");
	
	sleep(seconds);
	
	lock.l_type = F_UNLCK;
	check_error(fcntl(fd, F_SETLK, &lock) != -1, "....");
	
	close(fd); 
	
	exit(EXIT_SUCCESS);
}
