#define _XOPEN_SOURCE 700
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <errno.h>
#include <string.h>

#include <sys/wait.h>
#include <time.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

#define RD_END (0)
#define WR_END (1)
#define MAX_SIZE (1024)

int main(int argc, char** argv) {
	
	int par2cld[2];
	int cld2par[2];
	
	check_error(pipe(par2cld) != -1, "...");
	check_error(pipe(cld2par) != -1, "...");
	
	pid_t childPid = fork();
	check_error(childPid != -1, "....");
	
	if (childPid > 0) { // parent
			
		close(par2cld[RD_END]);
		close(cld2par[WR_END]);
		
		FILE* fd_in = fdopen(cld2par[RD_END], "r");
		check_error(fd_in != NULL, "...");
		
		FILE* fd_out = fdopen(par2cld[WR_END], "w");
		check_error(fd_out != NULL, "...");
		
		fprintf(fd_out, "Neka poruka: \n");
		fflush(fd_out);
		
		char buffer[MAX_SIZE];
		
		fgets(buffer, MAX_SIZE-1,fd_in);
		
		printf("Poruka od childa:\n%s\n", buffer);
		
		fclose(fd_in);
		fclose(fd_out);
	}
	else { // child
		
		close(par2cld[WR_END]);
		close(cld2par[RD_END]);
		
		FILE* fd_in = fdopen(par2cld[RD_END], "r");
		check_error(fd_in != NULL, "...");
		
		FILE* fd_out = fdopen(cld2par[WR_END], "w");
		check_error(fd_out != NULL, "...");
		
		char buffer[MAX_SIZE];
		
		time_t now = time(NULL);
		
		fgets(buffer, MAX_SIZE - 1, fd_in);
		
		int len = strlen(buffer);
		buffer[len-1] = ' '; 
		
		strcat(buffer, ctime(&now));
		
		fputs(buffer, fd_out);
		fflush(fd_out);
		
		fclose(fd_in);
		fclose(fd_out);
		
		exit(EXIT_SUCCESS);
	}
	
	check_error(wait(NULL) != -1, "...");
	
	exit(EXIT_SUCCESS);
}
