#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)

extern char** environ;

void print_env();

// ./1 fifo1 fifo2 .... fifon
int main(int argc, char** argv){
	
	//print_env();
	
	check_error(argc > 2, "...");
	
	if (argv[1][0] == '+') {
		
		check_error(setenv(argv[2], argv[3], 0) != -1, "....");
		
		char* value = getenv(argv[2]);
		check_error(value != NULL, "....");
	
		printf("%s\n", value);
	}
	else if (argv[1][0] == '-') {
		
		check_error(unsetenv(argv[2]) != -1, "....");
		
		char* value = getenv(argv[2]);
	
		printf("%s\n", value == NULL ? "nema" : "ima");
	}
	else {
	
		char* value = getenv(argv[1]);
		check_error(value != NULL, "....");
	
		printf("%s\n", value);
	}
	
	exit(EXIT_SUCCESS);
}

void print_env() {
	
	char** ep;
	
	for (ep = environ; *ep!=NULL; ep++){
		printf("%s\n", *ep);
	}
}
