#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <pthread.h>
#include <errno.h>

#define check_error(expr,userMsg)\
	do {\
		if (!(expr)) {\
			perror(userMsg);\
			exit(EXIT_FAILURE);\
		}\
	} while (0)
	
#define check_pthread(errNum,userMsg)\
	do{\
		int _errNum = (errNum); \
		if (_errNum > 0) {\
			errno = _errNum;\
			check_error(0, userMsg);\
		}\
	} while (0)

typedef struct {
	int idx;
} inArg_t;

typedef struct {
	int broj;
} outArg_t;

void* threadFunc(void* arg){
	
	inArg_t* data = arg;
	
	printf("Hello thread: %d\n", data->idx);
	
	outArg_t* out = malloc(sizeof(outArg_t));
	check_error(out != NULL, "....");
	
	out->broj = data->idx*data->idx;
	
	return out;
}

int main(int argc, char** argv) {
	
	check_error(argc == 2, "...");
	
	int numThread = atoi(argv[1]);
	
	pthread_t* tids = malloc(numThread*sizeof(pthread_t));
	check_error(tids != NULL, "...");
	
	inArg_t* args = malloc(numThread*sizeof(inArg_t));
	check_error(args != NULL, "....");
	
	for (int i = 0; i < numThread; i++) {
		
		args[i].idx = i+1;
		check_pthread(pthread_create(&tids[i], NULL, threadFunc, &args[i]), "....");
	}
	
	for (int i = 0; i < numThread; i++) {
		
		outArg_t* data = NULL;
		check_pthread(pthread_join(tids[i], (void**)&data) ,"...");
		printf("Return value: %d\n", data->broj);
		free(data);
	}
	
	free(tids);
	free(args);
	
	exit(EXIT_SUCCESS);
}
